---
title: KeyboardEvent.charCode
slug: Web/API/KeyboardEvent/charCode
tags:
  - API
  - DOM
  - Deprecated
  - KeyboardEvent
  - Property
  - Reference
---
<div>{{ ApiRef("DOM Events") }} {{non-standard_header}} {{deprecated_header}}</div>

<p>The <strong><code>charCode</code></strong> read-only property of the {{domxref("KeyboardEvent")}} interface returns the Unicode value of a character key pressed during a {{Event("keypress")}} event.</p>

<div class="notecard note">
<p><strong>Do not use this property, as it is deprecated.</strong> Instead, get the Unicode value of the character using the {{domxref("KeyboardEvent.key", "key")}} property.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>code</em> = <em>event</em>.charCode;
</pre>

<h3 id="Return_value">Return value</h3>

<p>A number that represents the Unicode value of the character key that was pressed.</p>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;Type anything into the input box below to log a &lt;code&gt;charCode&lt;/code&gt;.&lt;/p&gt;
&lt;input type="text" /&gt;
&lt;p id="log"&gt;&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">let input = document.querySelector('input');
let log = document.querySelector('#log');

input.addEventListener('keypress', function(e) {
  log.innerText = `Key pressed: ${String.fromCharCode(e.charCode)}\ncharCode: ${e.charCode}`;
});</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Notes">Notes</h2>

<ul>
 <li>In a {{Event("keypress")}} event, the Unicode value of the key pressed is stored in either the {{ domxref("KeyboardEvent.keyCode", "keyCode") }} or <code>charCode</code> property, but never both. If the key pressed generates a character (e.g., 'a'), <code>charCode</code> is set to the code of that character; <code>charCode</code> respects the letter case (in other words, <code>charCode</code> takes into account whether the <kbd>shift</kbd> key is held down). Otherwise, the code of the pressed key is stored in <code>keyCode</code>.</li>
 <li>When one or more modifier keys are pressed, there are some complex rules for <code>charCode</code>. See <a href="/en/Gecko_Keypress_Event" title="en/Gecko Keypress Event">Gecko Keypress Event</a> for details.</li>
 <li><code>charCode</code> is never set in the {{Event("keydown")}} and {{Event("keyup")}} events. In these cases, <code>keyCode</code> is set instead.</li>
 <li>To get the code of the key regardless of whether it was stored in <code>keyCode</code> or <code>charCode</code>, query the {{ domxref("KeyboardEvent.which", "which") }} property.</li>
 <li>Characters entered through an IME do not register through <code>keyCode</code> or <code>charCode</code>. <span class="comment">Actually with the Chinese IME I'm using, entering the IME results in a keypress event with keyCode = 229 and no other key events fire until the IME exits (which may happen after multiple characters are inputted). I'm not sure if other IME's work this way.</span></li>
 <li>For a list of the <code>charCode</code> values associated with particular keys, run <a href="/en-US/docs/Web/API/Document_Object_Model/Examples#Example_7:_Displaying_Event_Object_Properties" title="en/Gecko_DOM_Reference/Examples#Example_7:_Displaying_Event_Object_Constants">Example 7: Displaying Event Object Properties</a> and view the resulting HTML table.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM3 Events','#widl-KeyboardEvent-charCode','KeyboardEvent.charCode')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
   <td>Initial definition; specified as deprecated</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyboardEvent.charCode")}}</p>
